import pyodbc 
import csv

server = 'tcp:apa.di.unipi.it' 
database = 'Foodmart' 
username = 'lbi' 
password = 'pisa' 
cnxn = pyodbc.connect('DRIVER={ODBC Driver 17 for SQL Server};SERVER='+server+';DATABASE='+database+';UID='+username+';PWD='+ password)


timeid_monthyear = dict()
monthyear_nonsundays = dict()
cursor_time = cnxn.cursor()
cursor_time.execute("SELECT * FROM time_by_day;") 
row = cursor_time.fetchone() 
while row:
    month_and_year = row.month_of_year * 10000 + row.the_year
    timeid_monthyear[row.time_id] = month_and_year
    if(row.the_day != "Sunday"):
        if month_and_year not in monthyear_nonsundays:
            monthyear_nonsundays[month_and_year] = 0
        monthyear_nonsundays[month_and_year] += 1
    row = cursor_time.fetchone()
cursor_time.close()

customer_monthyear_sales = dict()
cursor = cnxn.cursor()
cursor.execute("SELECT * FROM sales_fact;") 
row = cursor.fetchone() 
while row:
    month_and_year = timeid_monthyear[row.time_id]
    if row.customer_id not in customer_monthyear_sales:
        customer_monthyear_sales[row.customer_id ] = dict()
    month_sales = customer_monthyear_sales[row.customer_id]
    if month_and_year not in month_sales:
        month_sales[month_and_year] = 0
    month_sales[month_and_year] += row.store_sales
    row = cursor.fetchone()
cursor.close()

with open('MDP.csv', 'w', newline='') as csvfile:
    fieldnames = ["customer_id", "month","year", "MDP"]
    writer = csv.DictWriter(csvfile, fieldnames=fieldnames)
    writer.writeheader()
    for customer in customer_monthyear_sales:
        month_sales = customer_monthyear_sales[customer]
        for monthyear in month_sales:
            month_num = monthyear // 10000
            year_num = monthyear % 10000
            MDP = month_sales[monthyear] / monthyear_nonsundays[monthyear]
            writer.writerow({"customer_id": customer, "month": month_num, "year":year_num, "MDP": MDP})